#include <iostream>
#include <fstream>
#include <cstdint>
#include <vector>
#include <cstring>
#include <algorithm>
#include <ctime>
struct Animal{
    size_t w, h, coordCount, realID;
    uint32_t min, divide;
    size_t coord[125][2];
};
std::vector<Animal> animals;
struct Jump{
    const Animal * __restrict__ animal;
    size_t x, y;
};
struct Backup{
    const Animal * __restrict__ animal;
    size_t w, h, x, y;
    uint32_t data[123];
};
struct Key{
    uint32_t price;
    uint32_t gain;
};
using Oper=std::pair<Key, Jump>;
struct Field{
    size_t w, h;
    uint32_t data[64][64];
    inline Key gain(Jump jump) const{
        uint32_t x=jump.x;
        uint32_t y=jump.y;
        uint32_t divide=jump.animal->divide;
        uint32_t min=jump.animal->min;
        uint32_t coordCount=jump.animal->coordCount;
        const size_t (*coord)[2]=jump.animal->coord;
        uint32_t res=0, price=0;
        for(size_t i=0;i<coordCount;i++){
            uint32_t ax=x+coord[i][0], ay=y+coord[i][1];
            if(data[ax][ay]<min) return Key{0,0};
            res+=data[ax][ay];
        }
        return Key{res+res/divide, res};
    }
    inline void apply(Jump jump, Backup &b){
        b.animal=jump.animal;
        uint32_t x=b.x=jump.x;
        uint32_t y=b.y=jump.y;
        uint32_t divide=jump.animal->divide;
        uint32_t coordCount=jump.animal->coordCount;
        const size_t (*coord)[2]=jump.animal->coord;
        for(size_t i=0;i<coordCount;i++){
            uint32_t ax=x+coord[i][0], ay=y+coord[i][1];
            b.data[i]=data[ax][ay];
            data[ax][ay]/=divide;
        }
        return;
    }
    inline void restore(const Backup &b){
        uint32_t x=b.x;
        uint32_t y=b.y;
        uint32_t coordCount=b.animal->coordCount;
        const size_t (*coord)[2]=b.animal->coord;
        for(size_t i=0;i<coordCount;i++){
            uint32_t ax=x+coord[i][0], ay=y+coord[i][1];
            data[ax][ay]=b.data[i];
        }
        return;
    }
    uint32_t totalMax=0;
    std::vector<Jump> maxSol, currSol;
    bool used[128]={0};
    uint32_t tryid=0;
    inline void genPos(std::vector<Oper> &pos){
        for(auto &i:animals){
            if(used[i.realID]) continue;
            for(size_t x=0;x+i.w<=w;x++){
                for(size_t y=0;y+i.h<=h;y++){
                    Jump j={&i,x,y};
                    Key g=gain(j);
                    if(g.gain!=0) pos.push_back(Oper(g, j));
                }
            }
        }
        return;
    }
    void max(uint32_t tillNow){
        std::vector<Oper> pos;
        genPos(pos);
        if(pos.empty()){
            if(tillNow>totalMax){
                totalMax=tillNow;
                maxSol=currSol;
            }
            if(tryid%256==0) if(clock()>CLOCKS_PER_SEC*185/100) throw 0;
            tryid++;
            return;
        }
        std::sort(pos.begin(), pos.end(),
            [](const Oper &a, const Oper &b)->bool{
                if(a.first.price>b.first.price) return 1;
                if(a.first.price<b.first.price) return 0;
                return a.first.gain>b.first.gain;
            }
        );
        Backup b;
        if(currSol.size()>8){
            apply(pos[0].second, b);
            currSol.push_back(pos[0].second);
            used[pos[0].second.animal->realID]=1;
            max(tillNow+pos[0].first.gain);
            used[pos[0].second.animal->realID]=0;
            currSol.pop_back();
            restore(b);
            if(pos.size()>1){
                apply(pos[1].second, b);
                currSol.push_back(pos[1].second);
                used[pos[1].second.animal->realID]=1;
                max(tillNow+pos[1].first.gain);
                used[pos[1].second.animal->realID]=0;
                currSol.pop_back();
                restore(b);
            }
        }else if(currSol.size()>4){
            apply(pos[0].second, b);
            currSol.push_back(pos[0].second);
            used[pos[0].second.animal->realID]=1;
            max(tillNow+pos[0].first.gain);
            used[pos[0].second.animal->realID]=0;
            currSol.pop_back();
            restore(b);
            if(pos.size()>1){
                apply(pos[1].second, b);
                currSol.push_back(pos[1].second);
                used[pos[1].second.animal->realID]=1;
                max(tillNow+pos[1].first.gain);
                used[pos[1].second.animal->realID]=0;
                currSol.pop_back();
                restore(b);
                if(pos.size()>2){
                    apply(pos[2].second, b);
                    currSol.push_back(pos[2].second);
                    used[pos[2].second.animal->realID]=1;
                    max(tillNow+pos[2].first.gain);
                    used[pos[2].second.animal->realID]=0;
                    currSol.pop_back();
                    restore(b);
                }
            }
        }else{
            for(auto &i:pos){
                apply(i.second, b);
                currSol.push_back(i.second);
                used[i.second.animal->realID]=1;
                max(tillNow+i.first.gain);
                used[i.second.animal->realID]=0;
                currSol.pop_back();
                restore(b);
            }
        }
        return;
    }
};
int main(){
    std::ifstream in("parash.in");
    std::ofstream out("parash.out");
    Field f;
    size_t acnt;
    in>>f.w>>f.h>>acnt;
    for(size_t i=0;i<f.w;i++){
        for(size_t j=0;j<f.h;j++){
            in>>f.data[i][j];
        }
    }
    animals.resize(acnt);
    size_t num=0;
    for(auto &i:animals){
        in>>i.w>>i.h>>i.divide>>i.min;
        i.realID=num++;
        for(size_t x=0;x<i.w;x++){
            for(size_t y=0;y<i.h;y++){
                char ch;
                in>>std::skipws>>ch;
                if(ch=='1'){
                    i.coord[i.coordCount][0]=x;
                    i.coord[i.coordCount][1]=y;
                    i.coordCount++;
                }
            }
        }
    }
    try{
        f.max(0);
    }catch(...){
    }
    #ifndef __WIN32
    std::cout<<f.totalMax<<std::endl;
    #endif
    out<<f.maxSol.size()<<'\n';
    for(auto &i:f.maxSol){
        out<<i.animal->realID+1<<' '<<i.x+1<<' '<<i.y+1<<'\n';
    }
    return 0;
}
